'use strict';
const Generator = require('yeoman-generator');
const chalk = require('chalk');
const yosay = require('yosay');
const mkdirp = require("mkdirp"); // 创建目录
const path = require('path');
var fs = require("fs");
const request = require('request');

function readDir(dir) {
  return fs.readdirSync(dir, (err, files) => {
    if (err) throw err;
    return files;
  })
}
function isEmptyDir(path) {
  let files = readDir(path);
  return !Boolean(files.length)
}
module.exports = class extends Generator {
  initializing() {
    const { chalk } = this.options.utils;

    this.log(yosay('welcome'));
    this.log(
      chalk.magenta(
        `尊贵的开发者，欢迎您好` +
        '\n' +
        '这是SlugTeam的项目脚手架' +
        '\n'
      )
    );
  }
  prompting() {
    const prompts = [{
      type: 'input',
      name: 'name',
      message: '请输入项目名称',
      default: 'my-project'
    }, {
      type: 'input',
      name: 'description',
      message: '请输入项目描述信息',
      default: '项目基本描述'
    }, {
      type: 'input',
      name: 'version',
      message: '请输入版本 (1.0.0):',
      default: '1.0.0'
    }]

    return this.prompt(prompts).then(props => {
      // To access props later use this.props.someAnswer;
      this.props = props;
    });
  }
  default() {
    re.http() // 这是那个错误
    if (path.basename(this.destinationPath()) === this.props.name && isEmptyDir(this.destinationPath())) {
      console.log(`当前文件夹${this.props.name}为项目文件夹`)
      return
    }

    const childPath = `${this.destinationPath()}/${this.props.name}`
    if (fs.existsSync(childPath)) {
      if (!isEmptyDir(childPath)) {
        console.log(`本地已存在该项目名(${this.props.name})文件夹, 请重新命名或删除原有文件夹`)
        process.exit();
      } else {
        this.log(`正在新建${this.props.name}文件夹`);
        mkdirp(this.props.name);
      }
    }
    this.destinationRoot(this.destinationPath(this.props.name))
  }
  writing() {
    this.fs.copyTpl(
      `${this.templatePath()}/**/*`,
      this.destinationPath(),
      this.props,
      {},
      { globOptions: { dot: true } }
    );
  }

  // install() {
  //   const { log } = this.options;
  //   log.info('安装依赖，过程持续1~2分钟');
  //   // this.npmInstall();
  // }

  // /**
  //  * Prompt user to start project
  //  */
  // end() {
  //   const { name } = this.answers;
  //   const { log } = this.options;
  //   const { chalk } = this.options.utils;

  //   log.info('本次初始化过程结束, 请通过以下命令运行项目: ');
  //   console.log();
  //   console.log(chalk.cyan('  cd'), name);
  //   console.log(`  ${chalk.cyan('feflow dev')}`);
  //   console.log();
  //   log.info('编码愉快!');
  // }
};